* cmdexec.s - part of execd
*

* Include File -------------------------------- *

		.include	doscall.mac


* Global Symol -------------------------------- *

		.xref	new_exec
		.xref	orig_exec
	.ifdef	CALL_GETPDB
		.xref	getpdb
	.endif
		.xref	dev_head
		.xref	title_dev
		.xref	title
		.xref	keep_id
		.xref	version_id
		.xref	version_mes

		.xref	no_current_search


* Fixed Number -------------------------------- *

LF:		.equ	$0a
CR:		.equ	$0d

		.ifdef	__CRLF__
CRLF:		.reg	CR,LF
		.else
CRLF:		.reg	LF
		.endif


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even

dev_end::

**** ܂ŏ풓 ****


**** foCXhCo ****

dev_init::
		pea	(title_dev,pc)
		DOS	_PRINT
		pea	(version_mes,pc)
		DOS	_PRINT
		addq.l	#8,sp

		bsr	hook_vector

		movea.l	(18,a5),a0
arg0_skip:
		tst.b	(a0)+
		bne	arg0_skip
arg_next:
		move.b	(a0)+,d0
		beq	dev_init_arg_end
		lsl	#8,d0
		move.b	(a0),d0
		cmpi	#'-c',d0
		bne	arg0_skip
		tst.b	(1,a0)
		bne	arg0_skip

		lea	(no_current_search,pc),a1
		not.b	(a1)
		bra	arg0_skip
dev_init_arg_end:
		lea	(dev_end,pc),a0
		move.l	a0,(14,a5)
		moveq	#0,d0
		rts


**** R}hC̎s ****

command_exec:
		bra.s	command_exec1
hupair_mark::
		.dc.b	'#HUPAIR',0
		.even

command_exec1:
		clr.l	-(sp)
		DOS	_SUPER
		addq.l	#4,sp

		pea	(1,a2)
		bsr	GetArgCharInit
		addq.l	#4,sp

		lea	(dev_head-$100,pc),a0
		lea	(keep_id,pc),a1
		bsr	keepchk
		lea	($100,a0),a6		;vZX(풓)dev_head
		move.l	d0,d7			;d7=0:풓Ă
		bpl	analyze_arg

		lea	(dev_head,pc),a0
		bsr	search_chrdev
		tst.l	d0
		beq	analyze_arg		;d7=-1:풓ĂȂ

		movea.l	d0,a6			;gݍ܂Ădev.dev_head
		moveq	#1,d7			;d7=1:foCXgݍ

;
analyze_arg:
		moveq	#0,d6
arg_loop:
		bsr	GetArgChar
		tst.l	d0
		bmi	arg_end
		beq	arg_loop
		cmpi.b	#'-',d0
		bne	_arg_error
next_option:
		bsr	GetArgChar
		tst.l	d0
		beq	arg_loop
		cmpi.b	#'-',d0
		beq	option_long
		cmpi.b	#'?',d0
		beq	print_usage
		ori.b	#$20,d0
		cmpi.b	#'c',d0
		beq	option_c
		cmpi.b	#'h',d0
		beq	print_usage
		cmpi.b	#'r',d0
		beq	option_r
		cmpi.b	#'v',d0
		beq	print_version
_arg_error:
		bra	arg_error

option_c:
		bsr	version_check
		bmi	version_error
		moveq	#-1,d6
		not.b	(no_current_search-dev_head,a6)
		bra	next_option

option_long:
		bsr	GetArgChar
		lea	(str_help,pc),a0
		cmp.b	(a0)+,d0
		seq	d1			;d1=$ff:--help
		beq	option_long_loop
		lea	(str_version,pc),a0
		bra	1f
option_long_loop:
		bsr	GetArgChar
1:		cmp.b	(a0)+,d0
		bne	_arg_error
		tst.b	d0
		bne	option_long_loop
		tst.b	d1
		bne	print_usage
		bra	print_version

print_version:
		pea	(version_id,pc)
		DOS	_PRINT
		DOS	_EXIT
print_usage:
		pea	(usage_mes,pc)
		bra	print_exit


;풓
option_r:
		bsr	version_check
		bmi	version_error

		tst.l	d7
		bmi	not_keeped_error
		beq	@f
		tst.l	(orig_exec-dev_head,a6)
		beq	already_released_error	;dev.Ă
@@:
		lea	(new_exec-dev_head,a6),a0
		lea	(orig_exec-dev_head,a6),a1
		bsr	unhook_vector
		tst.l	d0
		bmi	vec_change_error

		tst.l	d7
		bne	@f			;dev.͉̃Ȃ
		pea	(-$100+16,a6)
		DOS	_MFREE
		addq.l	#4,sp
@@:
		pea	(release_mes,pc)
print_exit:
		bsr	print_title
		DOS	_PRINT
		addq.l	#4,sp
dos_exit:
		DOS	_EXIT

;풓
arg_end:
		bsr	version_check
		bmi	version_error

		tst.l	d7
		bmi	install_proc
		beq	@f
		tst.l	(orig_exec-dev_head,a6)
		beq	install_dev		;dev.ԂȂċN
@@:
		tst.l	d6
		beq	already_keeped_error	;ɏ풓Ă

		pea	(opt_chg_mes,pc)	;풓-c͖Ȃ
		bra	print_exit

install_dev:
		bsr	rehook_vector
		bra	keep_end
install_proc:
		bsr	hook_vector
keep_end:
		bsr	print_title
		pea	(keep_mes,pc)
		DOS	_PRINT
		addq.l	#4,sp

		tst.l	d7
		bpl	dos_exit		;dev.ċN
		clr	-(sp)
		pea	(dev_end-dev_head).w
		DOS	_KEEPPR


;풓̃o[W
version_check:
		movem.l	a0-a1,-(sp)
		tst.l	d7
		bmi	version_check_end
		beq	version_check_proc

;title_dev`ׂ
		lea	(title_dev,pc),a0
		lea	(title_dev-dev_head,a6),a1
version_check_loop1:
		cmpm.b	(a0)+,(a1)+
		bne	version_check_error
		tst.b	(-1,a0)
		bne	version_check_loop1

version_check_proc:
		lea	(version_id,pc),a0
		lea	(version_id-dev_head,a6),a1
version_check_loop2:
		cmpm.b	(a0)+,(a1)+
		bne	version_check_error
		tst.b	(-1,a0)
		bne	version_check_loop2

version_check_end:
		moveq	#0,d0
@@:		movem.l	(sp)+,a0-a1
		rts
version_check_error:
		moveq	#-1,d0
		bra	@b


arg_error:
		pea	(usage_mes,pc)
		bra	error_exit
version_error:
		pea	(ver_err_mes,pc)
		bra	error_exit
not_keeped_error:
		pea	(rel_err_mes,pc)
		bra	error_exit
vec_change_error:
		pea	(rel_err2_mes,pc)
		bra	error_exit
already_released_error:
		pea	(rel_err3_mes,pc)
		bra	error_exit
already_keeped_error:
		pea	(keep_err_mes,pc)
		bra	error_exit
error_exit:
		bsr	print_title
		DOS	_PRINT
		move	#1,(sp)
		DOS	_EXIT2


print_title:
		pea	(title,pc)
		DOS	_PRINT
		pea	(version_mes,pc)
		DOS	_PRINT
		addq.l	#8,sp
		rts


hook_vector:
		movem.l	d0/a0-a1,-(sp)
		lea	(new_exec,pc),a0
		lea	(orig_exec,pc),a1
		bra	@f
rehook_vector:
		movem.l	d0/a0-a1,-(sp)
		lea	(new_exec-dev_head,a6),a0
		lea	(orig_exec-dev_head,a6),a1
@@:
		pea	(a0)
		move	#_EXEC,-(sp)
		DOS	_INTVCS
		addq.l	#6,sp
		move.l	d0,(a1)

		.ifdef	CALL_GETPDB
		move	#_GETPDB,-(sp)
		DOS	_INTVCG
		addq.l	#2,sp
		move.l	d0,(getpdb-orig_exec,a1)
		.endif

		movem.l	(sp)+,d0/a0-a1
		rts


* in	a0.l	new_exec(ݒ肳Ă锤̃AhX)
*	a1.l	orig_exec(̃AhXۑĂ郏[N)
unhook_vector:
		move	#_EXEC,-(sp)
		DOS	_INTVCG
		addq.l	#2,sp
		cmp.l	a0,d0
		bne	unhook_vector_error

		move.l	(a1),-(sp)
		move	#_EXEC,-(sp)
		DOS	_INTVCS
		addq.l	#6,sp
		clr.l	(a1)

		moveq	#0,d0
		rts
unhook_vector_error:
		moveq	#-1,d0
		rts


* 풓
* in	a0.l	̃Ǘ|C^
*	a1.l	ʗp̃AhX
* out	d0.l	 0 : 풓Ă
*		-1 : 풓ĂȂ
*	a0.l	Ǘ|C^
*			d0.l = 0 ̎A풓vZX̃Ǘ|C^
*			d0.l = -1̎ÃǗ|C^

		.offset	0
MSP_PREV:	.ds.l	1
MSP_KEEPFLAG:
MSP_PARENT:	.ds.l	1
MSP_END:	.ds.l	1
MSP_NEXT:	.ds.l	1
MSP_SIZE:
		.text

~idlen:		.reg	d3
~offset:	.reg	d4
~idstr:		.reg	a1
~mymsp:		.reg	a4

keepchk:
		movem.l	d1-d4/a1-a4,-(sp)
		lea	(a0),~mymsp

		move.l	~idstr,~offset
		sub.l	a0,~offset	;ʗp܂ł̃oCg

		lea	(~idstr),a2
@@:
		tst.b	(a2)+
		bne	@b
		subq.l	#1,a2
		suba.l	a1,a2
		move.l	a2,~idlen	;ʕ̒

		clr.l	-(sp)
		DOS	_SUPER
		move.l	d0,(sp)
@@:
		movea.l	(MSP_PARENT,a0),a0
		tst.l	(MSP_PARENT,a0)
		bne	@b

		moveq	#-1,d2		;풓tO
check_loop:
		cmp.b	(MSP_KEEPFLAG,a0),d2
		bne	next_msp

		lea	(a0,~offset.l),a2
		adda	~idlen,a2

		cmpa.l	(MSP_END,a0),a2
		bcc	next_msp

		suba	~idlen,a2
		lea	(~idstr),a3
		move	~idlen,d0
@@:
		cmp.b	(a2)+,(a3)+
		dbne	d0,@b
		beq	found
next_msp:
		move.l	(MSP_NEXT,a0),d0
		movea.l	d0,a0
		bne	check_loop

		lea	(~mymsp),a0
		bra	done

found:
		moveq	#0,d2
done:
		tst.b	(sp)
		bmi	@f
		DOS	_SUPER
@@:
		addq.l	#4,sp

		move.l	d2,d0
		movem.l	(sp)+,d1-d4/a1-a4
		rts


* LN^foCX
* in	a0.l	foCXwb_
*		(4,a0)`  1.w	foCX
*		(14,a0)` 8.b	foCX
*		L_r.
* out	d0.l	foCXwb_̃AhX.
*		ꍇ͈ԍŌ̃foCXԂ.
*		0̏ꍇ̓foCX݂͑Ȃ.
*
* CLOCKOɂfoCX(NUL,CON,AUX,PRN,LPT)͌łȂ.
* I[voȂfoCXł.

		.offset	0
		.ds.l	1
~dev_atr:	.ds	1
		.ds.l	2
~dev_name:	.ds.b	8
		.text

search_chrdev:
		movem.l	d1-d2/a0,-(sp)
		clr.l	-(sp)
		DOS	_SUPER
		move.l	d0,(sp)

		move	(~dev_atr,a0),d0
		move.l	(~dev_name+0,a0),d1
		move.l	(~dev_name+4,a0),d2

		movea.l	($1cb6),a0		;ClockDevice
search_chrdev_loop:
		cmp	(~dev_atr,a0),d0
		bne	search_chrdev_next
		cmp.l	(~dev_name+0,a0),d1
		bne	search_chrdev_next
		cmp.l	(~dev_name+4,a0),d2
		beq	search_chrdev_found
		bne	search_chrdev_next
search_chrdev_next:
		move.l	(a0),a0
		cmpa	#-1,a0
		bne	search_chrdev_loop

		suba.l	a0,a0
search_chrdev_found:
		tst.b	(sp)
		bmi	@f
		DOS	_SUPER
@@:		addq.l	#4,sp
		move.l	a0,d0
		movem.l	(sp)+,d1-d2/a0
		rts


* HUPAIR decoder ------------------------------ *

GetArgChar::
		movem.l	d1/a0-a1,-(sp)
		moveq	#0,d0
		lea	(GetArgChar_p,pc),a0
		movea.l	(a0)+,a1
		move.b	(a0),d0
		bmi	GetArgChar_noarg
GetArgChar_quate:
		move.b	d0,d1
GetArgChar_next:
		move.b	(a1)+,d0
		beq	GetArgChar_endarg
		tst.b	d1
		bne	GetArgChar_inquate
		cmpi.b	#' ',d0
		beq	GetArgChar_separate
		cmpi.b	#"'",d0
		beq	GetArgChar_quate
		cmpi.b	#'"',d0
		beq	GetArgChar_quate
GetArgChar_end:
		move.b	d1,(a0)
		move.l	a1,-(a0)
GetArgChar_abort:
		movem.l	(sp)+,d1/a0-a1
		rts
GetArgChar_endarg:
		st	(a0)
		bra	GetArgChar_abort
GetArgChar_noarg:
		moveq	#1,d0
		ror.l	#1,d0
		bra	GetArgChar_abort

GetArgChar_inquate:
		cmp.b	d0,d1
		bne	GetArgChar_end
		clr.b	d1
		bra	GetArgChar_next

GetArgChar_separate:
		cmp.b	(a1)+,d0
		beq	GetArgChar_separate
		moveq	#0,d0
		tst.b	-(a1)
		beq	GetArgChar_endarg
		bra	GetArgChar_end

GetArgCharInit::
		movem.l	a0-a1,-(sp)
		movea.l	(12,sp),a1
GetArgCharInit_skip:
		cmpi.b	#' ',(a1)+
		beq	GetArgCharInit_skip
		tst.b	-(a1)
		lea	(GetArgChar_c,pc),a0
		seq	(a0)
		move.l	a1,-(a0)
		movem.l	(sp)+,a0-a1
		rts


* Data Section -------------------------------- *

		.data

usage_mes:	.dc.b	'usage: execd [option]',CRLF
		.dc.b	'option:',CRLF
		.dc.b	'	-c	JgfBNgȂ.',CRLF
		.dc.b	'	-r	풓.',CRLF
		.dc.b	0

str_help:	.dc.b	'help',0
str_version:	.dc.b	'version',0

ver_err_mes:	.dc.b	'풓̃o[WႢ܂.',CRLF,0

keep_mes:	.dc.b	'풓܂.',CRLF,0
keep_err_mes:	.dc.b	'ɏ풓Ă܂.',CRLF,0
opt_chg_mes:	.dc.b	'ݒύX܂.',CRLF,0

release_mes:	.dc.b	'풓܂.',CRLF,0
rel_err_mes:	.dc.b	'풓Ă܂.',CRLF,0
rel_err2_mes:	.dc.b	'xN^ύXĂ܂.',CRLF,0
rel_err3_mes:	.dc.b	'łɉĂ܂.',CRLF,0


* Block Storage Section ----------------------- *

		.bss
		.even

GetArgChar_p:	.ds.l	1
GetArgChar_c:	.ds.b	1
		.even


		.end	command_exec

* End of File --------------------------------- *
