* getfirstpath.s - part of execd
*
*	input - a3:path environment variable address
*		a1:first path buffer
*		a0:basename pointer(terminate with space or tab or null)
*
*	output- d1.b:0...empty path
*		a1:firstpathname null pointer
*
*	destroy - a0,d0


* Text Section -------------------------------- *

	.cpu	68000

	.text
	.even

getfirstpath::
	move.l	a3,d0
	beq	no_path
	moveq	#';',d0

getfirstpath_loop:
	move.b	(a3)+,d1
	beq	concat
	bmi	kanji_check
	cmp.b	d0,d1			* ';'
	beq	concat
is_not_kanji:
	move.b	d1,(a1)+
	bra	getfirstpath_loop
kanji_check:
	cmpi.b	#$a0,d1
	bcs	is_kanji
	cmpi.b	#$e0,d0
	bcs	is_not_kanji
is_kanji:
	move.b	d1,(a1)+
	move.b	(a3)+,(a1)+
	bra	getfirstpath_loop

concat:
	moveq	#'\',d0
concat_loop:
	move.b	d0,(a1)+
no_path:
	move.b	(a0)+,d0
	beq	return
	cmpi.b	#$09,d0			;TAB
	beq	return
	cmpi.b	#' ',d0
	bne	concat_loop
return:
	clr.b	(a1)
	rts

	.end

* End of File --------------------------------- *
