* script.s - part of execd
*
*   (a6).w..MD
*  2(a6).l..fil(script name)
*  6(a6).l..p1 (arguments)
* 10(a6).l..p2 (environment pointer)


* Include File -------------------------------- *

	.include doscall.mac


* Global Symbol ------------------------------- *

	.xref	loadscript
	.xref	concat
	.xref	exec1


* Text Section -------------------------------- *

	.cpu	68000

	.text
	.even

exec1_script::
	cmpi.l	#-11,d0
	bne	error

	pea	(256+256+8).w
	DOS	_MALLOC
	move.l	d0,(sp)+
	bmi	malloc_error
	movea.l	d0,a1

	lea	(256,a1),a0
	lea	(hupair_mark,pc),a2
hupair_mark_loop:
	move.b	(a2)+,(a0)+
	bne	hupair_mark_loop

	move.l	(2,a6),a0
	bsr	loadscript
	bmi	read_error

	movea.l	(10,a6),a4
	movea.l	(6,a6),a3
	movea.l	(2,a6),a2
	bsr	concat
	bmi	concat_error

	move.l	a1,-(sp)

	move.l	(10,a6),-(sp)
	pea	(256+8,a1)
	move.l	a5,-(sp)
	move	#1,-(sp)
	movea.l	sp,a6
	bsr	exec1
	lea	(14,sp),sp
	tst.l	d0
	bmi	exec_error

	move.l	a1,-(sp)
	movea.l	(4,sp),a1
	move.l	a0,(-16+4,a1)	* hack memory chain
	movea.l	(sp)+,a1
	addq.l	#4,sp

malloc_error:
error:
	tst.l	d0
	rts

exec_error:
	movea.l	(sp)+,a1

read_error:
concat_error:
	move.l	d0,d1
	move.l	a1,-(sp)
	DOS	_MFREE
	addq.l	#4,sp
	move.l	d1,d0
	bra	error

hupair_mark:
	.dc.b	'#HUPAIR',0
	.even

	.end

* End of File --------------------------------- *
