* checkexec.s - part of execd
*
* input - a0:execname address
*
* output - d0.l: 0 - can exec, nonzero - cannot exec
*	   a0:(modified execname)
*
* destroy - a1

	.include doscall.mac

	.xdef	checkexec

execp:	.macro	ch
	.local	next
	move.b	ch,(a1)
	DOS	_CHMOD
	tst.l	d0
	bmi	next
	btst	#4,d0
	beq	found_file
next:
	.endm

	.cpu	68000
	.text

checkexec:

	movea.l	a0,a1

	move	#-1,-(sp)
	pea	(a0)
	DOS	_CHMOD
	tst.l	d0
	bmi	concat_loop
	btst	#4,d0
	beq	found_file

concat_loop:
	tst.b	(a1)+
	bne	concat_loop

	move.b	#'.',(-1,a1)
	clr.b	(1,a1)

	execp	#'r'
	execp	#'R'
	execp	#'x'
	execp	#'X'
	execp	#'z'
	execp	#'Z'

	moveq	#-2,d0
	clr.b	-(a1)
	bra	not_found

found_file:
	moveq	#0,d0

not_found:
	addq.l	#6,sp
	rts

	.end
