* getenv.s - part of execd
*
* input  - a3:environment pointer(null::my process environment)
*
* output - a3:environment path pointer
*	      (0:'path' is not found)


* Include File -------------------------------- *

	.include doscall.mac


* Global Symbol ------------------------------- *

	.ifdef	CALL_GETPDB
	.xref	getpdb
	.endif


* OS Work ------------------------------------- *

	.ifndef	CALL_GETPDB
PSPPointer:	.equ	$1c28
	.endif


* Text Section -------------------------------- *

	.cpu	68000

	.text
	.even
getenv::
	move.l	a0,-(sp)
	move.l	a3,d0
	bmi	not_found
	bne	test_length

	.ifdef	CALL_GETPDB
	movem.l	d1-d7/a0-a6,-(sp)
	movea.l	(getpdb,pc),a0
	jsr	(a0)
	movem.l	(sp)+,d1-d7/a0-a6
	movea.l	d0,a3
	movea.l	(a3),a3
	.else
	movea.l	(PSPPointer),a3		;human3.02Ȃa3=$13d0a
	movea.l	(a3),a3
	movea.l	(16,a3),a3
	.endif

	move.l	a3,($c00000)
	move.l	a3,d0
	ble	not_found

test_length:
	tst.l	(a3)+
	beq	not_found

getenv_loop:
	cmpi.b	#'p',(a3)+
	bne	next_env
	cmpi.b	#'a',(a3)+
	bne	next_env
	cmpi.b	#'t',(a3)+
	bne	next_env
	cmpi.b	#'h',(a3)+
	bne	next_env
	cmpi.b	#'=',(a3)+
	beq	return
next_env:
	subq.l	#1,a3
next_env_loop:
	tst.b	(a3)+
	bne	next_env_loop
	tst.b	(a3)
	bne	getenv_loop

not_found:
	suba.l	a3,a3
return:
	move.l	(sp)+,a0
	rts

	.end

* End of File --------------------------------- *
