* loadscript.s - part of execd
*
* a0.l..script name
* a1.l..buffer at least 256 bytes, align 2 bytes
*
* output: d0.l (read length. minus..error)


* Include File -------------------------------- *

	.include doscall.mac


* Text Section -------------------------------- *

	.cpu	68000

	.text
	.even

loadscript::
	clr	-(sp)
	move.l	a0,-(sp)
	DOS	_OPEN
	addq.l	#6,sp
	move.l	d0,d1
	bmi	error

	pea	(255).w		* max char of line
	move.l	a1,-(sp)
	move	d1,-(sp)
	DOS	_READ
	lea	(10,sp),sp
	move.l	d0,d2
	bmi	read_error

	move	d1,-(sp)
	DOS	_CLOSE
	addq.l	#2,sp
	tst.l	d0
	bmi	error

	clr.b	(a1,d2.l)
	cmpi	#'#!',(a1)
	bne	fmt_error

	move.l	d2,d0
error:
	rts

read_error:
	move.l	d0,-(sp)
	move	d1,-(sp)
	DOS	_CLOSE
	addq.l	#2,sp
	move.l	(sp)+,d0
	rts			;bra	error

fmt_error:
	moveq	#-11,d0
	rts			;bra	error

	.end

* End of File --------------------------------- *
